﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

namespace SfDataGridBugDemo
{
    public class MainViewModel : INotifyPropertyChanged
    {
        private SongList _songs;
        public SongList Songs
        {
            get => _songs;
            set
            {
                if (Equals(value, _songs)) return;
                _songs = value;
                OnPropertyChanged();
            }
        }

        private ObservableCollection<string> _playlists = new ObservableCollection<string>()
        {
            "Sample music",
            "Favorites",
            "Library"
        };

        public ObservableCollection<string> Playlists
        {
            get => _playlists;
            set
            {
                if (Equals(value, _playlists)) return;
                _playlists = value;
                OnPropertyChanged();
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}