﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Xamarin.Forms;

namespace SfDataGridBugDemo
{
    public class SongList : INotifyPropertyChanged
    {
        internal static List<Song> SampleMusic => new List<Song>
        {
            new Song("Back to Us","Don Diablo", TimeSpan.FromSeconds(180), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Everybody's Somebody","Don Diablo", TimeSpan.FromSeconds(180 + 18), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Put It on for Me","Don Diablo", TimeSpan.FromSeconds(180 + 23), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Give Me Love","Don Diablo", TimeSpan.FromSeconds(180 + 28), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Higher","Don Diablo", TimeSpan.FromSeconds(180 + 0), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Take Her Place","Don Diablo", TimeSpan.FromSeconds(180 + 29), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Head Up","Don Diablo", TimeSpan.FromSeconds(180 + 11), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Bright Skies (The Bit U Know)","Don Diablo", TimeSpan.FromSeconds(180 + 37), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Found You","Don Diablo", TimeSpan.FromSeconds(180 + 9), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Reflections","Don Diablo", TimeSpan.FromSeconds(180 + 93), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("You Can't Change Me","Don Diablo", TimeSpan.FromSeconds(180 + 7), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Don't Let Go","Don Diablo", TimeSpan.FromSeconds(180 + 12), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Killer","Don Diablo", TimeSpan.FromSeconds(180 + 67), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("People Say","Don Diablo", TimeSpan.FromSeconds(180 + 8), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Satellites","Don Diablo", TimeSpan.FromSeconds(180 + 30), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Echoes","Don Diablo", TimeSpan.FromSeconds(180 + 56), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Believe","Don Diablo", TimeSpan.FromSeconds(180 + 37), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Gangsta Ways","Don Diablo", TimeSpan.FromSeconds(180 + 0), "Future", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Anthem (We Love House Music)","Don Diablo", TimeSpan.FromSeconds(180 + 39), "Single", 320, "token", "path", "Unknown", new DateTime(2018,6,8)),
            new Song("Wake Me When It's Quiet","Don Diablo", TimeSpan.FromSeconds(180 + 35), "Single", 320, "token", "path", "Unknown", new DateTime(2018,5,14)),
            new Song("Kids In Love","Don Diablo", TimeSpan.FromSeconds(180 + 15), "Single", 320, "token", "path", "Unknown", new DateTime(2018,5,11)),
            new Song("Drifter (feat. Dyu)","Don Diablo", TimeSpan.FromSeconds(180 +0), "Single", 320, "token", "path", "Unknown", new DateTime(2018,2,9)),
            new Song("Momentum","Don Diablo", TimeSpan.FromSeconds(180 + 40), "Single", 320, "token", "path", "Unknown", new DateTime(2017,11,24)),
            new Song("Knight Time","Don Diablo", TimeSpan.FromSeconds(180 + 144), "Single", 320, "token", "path", "Unknown", new DateTime(2017,10,5)),
            new Song("Starlight (Could You Be Mine)","Don Diablo", TimeSpan.FromSeconds(180 +19), "Single", 320, "token", "path", "Unknown", new DateTime(2017,6,30)),
            new Song("Save a Little Love","Don Diablo", TimeSpan.FromSeconds(180 + 19), "Single", 320, "token", "path", "Unknown", new DateTime(2017,8,18)),
            new Song("Got The Love","Don Diablo", TimeSpan.FromSeconds(180 + 73), "Single", 320, "token", "path", "Unknown", new DateTime(2017,6,1)),
            new Song("Switch","Don Diablo", TimeSpan.FromSeconds(180 - 7), "Single", 320, "token", "path", "Unknown", new DateTime(2017,5,5)),
            new Song("Something Just Like This","Don Diablo", TimeSpan.FromSeconds(180 + 50), "Single", 320, "token", "path", "Unknown", new DateTime(2017,4,28)),
            new Song("Children Of A Miracle","Don Diablo", TimeSpan.FromSeconds(180 + 9), "Single", 320, "token", "path", "Unknown", new DateTime(2017,3,17)),
            new Song("Generations","Don Diablo", TimeSpan.FromSeconds(180 + 25), "Single", 320, "token", "path", "Unknown", new DateTime(2017,2,24)),
            new Song("Tonight","Don Diablo", TimeSpan.FromSeconds(180 + 56), "Single", 320, "token", "path", "Unknown", new DateTime(2018,2,2)),
            new Song("Tunnel Vision","Don Diablo", TimeSpan.FromSeconds(180 + 105), "Single", 320, "token", "path", "Unknown", new DateTime(2017,1,27)),
            new Song("Cutting Shapes","Don Diablo", TimeSpan.FromSeconds(180 + 62), "Single", 320, "token", "path", "Unknown", new DateTime(2017,12,1)),
            new Song("What We Started (feat. BullySongs)","Don Diablo", TimeSpan.FromSeconds(180 + 36), "Single", 320, "token", "path", "Unknown", new DateTime(2016,8,5)),
            new Song("Good Grief","Don Diablo", TimeSpan.FromSeconds(180 + 59), "Single", 320, "token", "path", "Unknown", new DateTime(2016,7,8)),
            new Song("Close My Eyes","Don Diablo", TimeSpan.FromSeconds(180 + 102), "Single", 320, "token", "path", "Unknown", new DateTime(2016,4,11)),
            new Song("I'll House You (feat. Jungle Brothers)","Don Diablo", TimeSpan.FromSeconds(180 +50), "Single", 320, "token", "path", "Unknown", new DateTime(2016,1,12)),
            new Song("Secrets feat. Vassy","Don Diablo", TimeSpan.FromSeconds(180 + 79), "Single", 320, "token", "path", "Unknown", new DateTime(2015,8,10)),
            new Song("Universe feat. Emeni","Don Diablo", TimeSpan.FromSeconds(180 + 76), "Single", 320, "token", "path", "Unknown", new DateTime(2015,7,3)),
            new Song("My Window feat. Maluca","Don Diablo", TimeSpan.FromSeconds(180 - 4), "Single", 320, "token", "path", "Unknown", new DateTime(2015,6,26)),
            new Song("Chain Reaction (Domino)","Don Diablo", TimeSpan.FromSeconds(180 + 74), "Single", 320, "token", "path", "Unknown", new DateTime(2015,4,24)),
            new Song("Generations","Don Diablo", TimeSpan.FromSeconds(180 + 113), "Single", 320, "token", "path", "Unknown", new DateTime(2014,12,8)),
            new Song("Back To Life","Don Diablo", TimeSpan.FromSeconds(180 + 124), "Single", 320, "token", "path", "Unknown", new DateTime(2014,10,20)),
            new Song("Don't","Don Diablo", TimeSpan.FromSeconds(180 + 69), "Single", 320, "token", "path", "Unknown", new DateTime(2014,10,19)),
            new Song("Back In Time","Don Diablo", TimeSpan.FromSeconds(180 + 67), "Single", 320, "token", "path", "Unknown", new DateTime(2014,9,22)),
            new Song("Knight Time","Don Diablo", TimeSpan.FromSeconds(180 + 144), "Single", 320, "token", "path", "Unknown", new DateTime(2014,9,15)),
            new Song("AnyTime","Don Diablo", TimeSpan.FromSeconds(180 + 94), "Single", 320, "token", "path", "Unknown", new DateTime(2014,8,4)),
            new Song("Black Mask","Don Diablo", TimeSpan.FromSeconds(180 + 93), "Single", 320, "token", "path", "Unknown", new DateTime(2014,3,21)),
            new Song("Origins","Don Diablo", TimeSpan.FromSeconds(180 + 84), "Single", 320, "token", "path", "Unknown", new DateTime(2013,12,9)),
            new Song("M1 Stinger","Don Diablo", TimeSpan.FromSeconds(180 + 24), "Single", 320, "token", "path", "Unknown", new DateTime(2012,12,14))
        };

        private ObservableCollection<Song> _songs;

        public ObservableCollection<Song> Songs
        {
            get => _songs;
            set
            {
                if (Equals(value, _songs))
                    return;
                _songs = value;
                OnPropertyChanged();
            }
        }

        public SongList()
        {
            Songs = new ObservableCollection<Song>();
        }

        public async Task UpdatePlaylist()
        {
            await Task.Run(async () =>
            {
                await ProcessFolder(20);
            });
        }

        public async Task ProcessFolder(int subfolders)
        {
            for (int i = 0; i < subfolders; i++)
            {
                await ProcessFolder(0);
            }
            await ProcessFiles();
        }

        public async Task ProcessFiles()
        {
            foreach (var storageFile in SampleMusic)
            {
                await ProcessFile(storageFile);
            }
        }

        private Random _random = new Random();

        public async Task ProcessFile(Song song)
        {
            bool played = _random.Next(2) == 0;
            song.Played = played;
            await AddSong(song);
        }

        public async Task AddSong(Song song)
        {
            await BeginInvokeOnMainThreadAsync(() => Songs.Add(song));
        }

        private static Task BeginInvokeOnMainThreadAsync(Action action)
        {
            TaskCompletionSource<object> tcs = new TaskCompletionSource<object>();
            Device.BeginInvokeOnMainThread(() =>
            {
                try
                {
                    action();
                    tcs.SetResult(null);
                }
                catch (Exception ex)
                {
                    tcs.SetException(ex);
                }
            });
            return tcs.Task;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}